<script setup lang="ts">
import {computed, onMounted, ref} from "vue";

const textarea = ref<HTMLInputElement|null>(null);

const props = defineProps({
    autogrow: Boolean
})

const autogrowClasses = computed(() => {
  if(!props.autogrow){
    return '';
  }

  return 'overflow-hidden resize-none';
})

const autogrowTextarea = () => {
  const element = textarea.value;

  if(!element){
    return;
  }

  element.style.height = "7px"
  element.style.height = (element.scrollHeight) + "px"
}

onMounted(() => {
  autogrowTextarea();
})
</script>

<template>
  <textarea
      ref="textarea"
      class="text-sm text-gray-900 bg-gray-50 rounded-main border border-gray-300 focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
      :class="autogrowClasses"
      @input="autogrowTextarea"
  />
</template>